package lawOfDemeter;

import org.aspectj.lang.reflect.*;
import org.aspectj.lang.*;
import testcase.*;            // general tests

/**
 * @author Paul Freeman
 */

public class Tests {

  public static void main(String[] args){
  }

  pointcut run():
    execution(void Tests.main(String[]));

  pointcut specificRun():
    call(* *Test*(..)) && !Any.scope();
}

privileged aspect GeneralTests{

  void around(): Tests.specificRun(){
    System.out.println("*** running " +
      ((MethodSignature)thisJoinPointStaticPart.getSignature()).getName() +
      " ***");
    proceed();
    System.out.println("");
  }

  before(): Tests.run(){
    ATest();
    OriginalFooTest();
  }

  public void ATest(){
    Main m = new Main();
    m.DirectPartsTests();
    m.LocallyConstructedTests();
    m.ReturnTypeTests();
    m.ArgumentTests(new testcase.A());
  }

  public void OriginalFooTest(){
    testcase.Foo.main(new String[0]);
  }
}