package lawOfDemeter;

/**
 * @author Pengcheng Wu
 */

import java.util.*;
import org.aspectj.lang.reflect.*;
import org.aspectj.lang.*;

aspect Checker {
   before(): Any.Call() {

    // CORRECTED CODE - was examining declaring type of the method and not target
    //                  object.  Declaring type of superclass methods is the super
    //                  class itself, so was looking for wrong Class in some instances.
    //                  Corrected code also allows calls to static methods.
       Object targetObj = thisJoinPoint.getTarget();
       if(targetObj == null)
          return;   // static method call
       // else
       Class targetType = thisJoinPoint.getTarget().getClass();
//       Class targetType = thisJoinPointStaticPart.getSignature().getDeclaringType();
    // END CORRRECTED CODE
       Class thisType = thisEnclosingJoinPointStaticPart.getSignature().getDeclaringType();

       if(LoDPointCutsGlobal.prefSuppliers.containsKey(thisType)) {
          Class[] alloweds = (Class[])LoDPointCutsGlobal.prefSuppliers.get(thisType);
          for(int i=0; i<alloweds.length; i++) {
            if(targetType==alloweds[i]){
               return;
            }
          }
       }

    // CODE CHANGE - for testing
//       HashSet innermost = (HashSet)LoDPointCutsContext.stackPrefSuppliers.peek();
//
//       if(innermost.contains(targetType))
//             return;
       if(LoDPointCutsContext.prefSuppliers.contains(targetType))
             return;
    // END CODE CHANGE

       System.out.println("Violation Found at "+
          thisJoinPoint.getSourceLocation().getFileName() + ":" +
          thisJoinPoint.getSourceLocation().getLine() + ":" +
          thisJoinPoint.getSourceLocation().getColumn() + " jp " +
          thisJoinPoint);
   }

}
